##### Update theta #############################################################
update.theta <- function(SigmaInv.diag, VInv.diag, u, v, sv, w) {
    Q <- F.spam.prime %*% (SigmaInv.diag * F.spam)
    diag(Q) <- diag(Q) + VInv.diag
    U <- update.spam.chol.NgPeyton(U.theta.init, Q)
    VinvM <- F.prime %*% (SigmaInv.diag * (y - (u[which.countryTime] + v[which.regionTime] + 
        sv[which.sregionTime] + w[which.time]) - varphiPlusC.age))
    return(backsolve(U, forwardsolve(U, VinvM, trans = T) + rnorm(length(VinvM))))
}

##### Function returns u.star, P(u.star|theta.star,dot), #######################
##### P(u[i-1,]|theta.old,dot) and a proposed u|theta.old ######################
##### in case u.star is rejected ###############################################
u.prop.function <- function(i, tPtsPer, V1Inv.diag, Vinv.M, theta.star, theta.old, 
    u.old) {
    switch(paste("val", tPtsPer[i], sep = ""), val0 = {
        uStar <- eigenNoData$vec %*% (1/sqrt(exp(theta.star) * eigenNoData$val) * 
            rnorm(T))
        uStar.old <- eigenNoData$vec %*% (1/sqrt(exp(theta.old) * eigenNoData$val) * 
            rnorm(T))
        dens <- 1/2 * (T - 2) * theta.star - 1/2 * t(uStar) %*% (exp(theta.star) * 
            SigmaGenInvNoTheta %*% uStar)
        dens.old <- 1/2 * (T - 2) * theta.old - 1/2 * t(u.old[((i - 1) * T + 1):(i * 
            T)]) %*% (exp(theta.old) * SigmaGenInvNoTheta %*% u.old[((i - 1) * T + 
            1):(i * T)])
        return(list(u.star = uStar, dens.star = dens, u.star.old = uStar.old, dens.old = dens.old))
    }, val1 = {
        Q <- exp(theta.star) * P
        diag(Q) <- diag(Q) + V1Inv.diag[((i - 1) * T + 1):(i * T)]
        Q.eigen <- eigen(Q)
        Q.eigen$values[T] <- Inf
        Qinv <- Q.eigen$vectors %*% (1/Q.eigen$values * t(Q.eigen$vectors))
        correct.factor <- Qinv %*% matrix(1, T, T)/sum(Qinv)
        mu <- Qinv %*% Vinv.M[((i - 1) * T + 1):(i * T)]
        muStar <- mu - correct.factor %*% mu
        SigmaStar <- Qinv - correct.factor %*% Qinv
        SigmaStar.eigen <- eigen(SigmaStar)
        SigmaStar.eigen$val[(T - 1):T] <- 0
        EigenValGenInv <- 1/SigmaStar.eigen$val
        EigenValGenInv[(T - 1):T] <- 0
        SigmaGenInv <- SigmaStar.eigen$vec %*% (EigenValGenInv * t(SigmaStar.eigen$vec))
        uStar <- muStar + SigmaStar.eigen$vec %*% (sqrt(SigmaStar.eigen$val) * rnorm(T))
        dens <- -1/2 * sum(log(SigmaStar.eigen$val[1:(T - 2)])) - 1/2 * t(uStar - 
            muStar) %*% (SigmaGenInv %*% (uStar - muStar))
        Q <- exp(theta.old) * P
        diag(Q) <- diag(Q) + V1Inv.diag[((i - 1) * T + 1):(i * T)]
        Q.eigen <- eigen(Q)
        Q.eigen$values[T] <- Inf
        Qinv <- Q.eigen$vectors %*% (1/Q.eigen$values * t(Q.eigen$vectors))
        correct.factor <- Qinv %*% matrix(1, T, T)/sum(Qinv)
        mu <- Qinv %*% Vinv.M[((i - 1) * T + 1):(i * T)]
        muStar <- mu - correct.factor %*% mu
        SigmaStar <- Qinv - correct.factor %*% Qinv
        SigmaStar.eigen <- eigen(SigmaStar)
        SigmaStar.eigen$val[(T - 1):T] <- 0
        EigenValGenInv <- 1/SigmaStar.eigen$val
        EigenValGenInv[(T - 1):T] <- 0
        SigmaGenInv <- SigmaStar.eigen$vec %*% (EigenValGenInv * t(SigmaStar.eigen$vec))
        uStar.old <- muStar + SigmaStar.eigen$vec %*% (sqrt(SigmaStar.eigen$val) * 
            rnorm(T))
        dens.old <- -1/2 * sum(log(SigmaStar.eigen$val[1:(T - 2)])) - 1/2 * t(u.old[((i - 
            1) * T + 1):(i * T)] - muStar) %*% (SigmaGenInv %*% (u.old[((i - 1) * 
            T + 1):(i * T)] - muStar))
        return(list(u.star = uStar, dens.star = dens, u.star.old = uStar.old, dens.old = dens.old))
    }, {
        Q <- exp(theta.star) * P
        diag(Q) <- diag(Q) + V1Inv.diag[((i - 1) * T + 1):(i * T)]
        Qinv <- solve(Q)
        correct.factor <- Qinv %*% t(A) %*% solve(A %*% Qinv %*% t(A)) %*% A
        mu <- Qinv %*% Vinv.M[((i - 1) * T + 1):(i * T)]
        muStar <- mu - correct.factor %*% mu
        SigmaStar <- Qinv - correct.factor %*% Qinv
        SigmaStar.eigen <- eigen(SigmaStar)
        SigmaStar.eigen$val[(T - 1):T] <- 0
        EigenValGenInv <- 1/SigmaStar.eigen$val
        EigenValGenInv[(T - 1):T] <- 0
        SigmaGenInv <- SigmaStar.eigen$vec %*% (EigenValGenInv * t(SigmaStar.eigen$vec))
        uStar <- muStar + SigmaStar.eigen$vec %*% (sqrt(SigmaStar.eigen$val) * rnorm(T))
        dens <- -1/2 * sum(log(SigmaStar.eigen$val[1:(T - 2)])) - 1/2 * t(uStar - 
            muStar) %*% (SigmaGenInv %*% (uStar - muStar))
        Q <- exp(theta.old) * P
        diag(Q) <- diag(Q) + V1Inv.diag[((i - 1) * T + 1):(i * T)]
        Qinv <- solve(Q)
        correct.factor <- Qinv %*% t(A) %*% solve(A %*% Qinv %*% t(A)) %*% A
        mu <- Qinv %*% Vinv.M[((i - 1) * T + 1):(i * T)]
        muStar <- mu - correct.factor %*% mu
        SigmaStar <- Qinv - correct.factor %*% Qinv
        SigmaStar.eigen <- eigen(SigmaStar)
        SigmaStar.eigen$val[(T - 1):T] <- 0
        EigenValGenInv <- 1/SigmaStar.eigen$val
        EigenValGenInv[(T - 1):T] <- 0
        SigmaGenInv <- SigmaStar.eigen$vec %*% (EigenValGenInv * t(SigmaStar.eigen$vec))
        uStar.old <- muStar + SigmaStar.eigen$vec %*% (sqrt(SigmaStar.eigen$val) * 
            rnorm(T))
        dens.old <- -1/2 * sum(log(SigmaStar.eigen$val[1:(T - 2)])) - 1/2 * t(u.old[((i - 
            1) * T + 1):(i * T)] - muStar) %*% (SigmaGenInv %*% (u.old[((i - 1) * 
            T + 1):(i * T)] - muStar))
        return(list(u.star = uStar, dens.star = dens, u.star.old = uStar.old, dens.old = dens.old))
    })
}

##### Log likelihood ###########################################################
LogLik <- function(SigmaInv.diag, gamma, R.age.spam, F.theta.Mm) {
    return(0.5 * (sum(log(SigmaInv.diag)) - sum(SigmaInv.diag * (y - F.theta.Mm - 
        R.age.spam %*% gamma)^2)))
}

##### Prior for the study-specific random effects ##############################
ssreLik <- function(N, phi, ssre) {
    return((-N * phi - sum(ssre^2)/exp(phi))/2)
}

##### Log gelman prior for phi #################################################
LogPriorPhi <- function(phi) {
    return(phi/2)
}

##### Log posterior for theta_c, theta_r, theta_g ##############################
CalcThetaPost <- function(i, uvw) {
    return(uvw[((i - 1) * T + 1):(i * T)] %*% P %*% uvw[((i - 1) * T + 1):(i * T)])
}
LogPostThetaC <- function(theta_c, u) {
    return((J * (T - 2) - 1) * theta_c/2 - exp(theta_c)/2 * sum(unlist(lapply(1:J, 
        CalcThetaPost, u))))
}
LogPostThetaR <- function(theta_r, v) {
    return((sum(multipleRegionsInSregion) * (T - 2) - 1) * theta_r/2 - exp(theta_r)/2 * 
        sum(unlist(lapply((1:K)[multipleRegionsInSregion], CalcThetaPost, v))))
}
LogPostThetaS <- function(theta_s, sv) {
    return((L * (T - 2) - 1) * theta_s/2 - exp(theta_s)/2 * sum(unlist(lapply(1:L, 
        CalcThetaPost, sv))))
}
LogPostThetaG <- function(theta_g, w) {
    return((T - 2 - 1) * theta_g/2 - exp(theta_g)/2 * w %*% P %*% w)
}

##### Log gelman prior for phi_r, eta_r, phi_c, eta_c, on sd scale #############
LogPriorSD <- function(sd) {
    return((-2 * epsilona.gelman - 1) * log(sd))
}

##### Tuning function ##########################################################
adaptJump <- function(n, pjump, pgoal = NULL, max.mult = 5) {
    pjump[pjump == 1] = 0.999
    if (is.null(pgoal)) {
        const = rep(log(0.44), length(n))
        const[n == 2] = log(0.35)
        const[n == 3] = log(0.32)
        const[n > 3] = log(0.25)
    } else {
        const = log(pgoal)
    }
    return(min(max.mult, max(1/max.mult, const/log(pjump))))
}

##### Print deviance to screen #################################################
printDeviance <- function() {
    mean.deviance <- round(mean(deviance[burnt], na.rm = T), 2)
    p_D <- round(var(deviance[burnt], na.rm = T)/2, 2)
    dic <- round(mean(deviance[burnt], na.rm = T) + var(deviance[burnt], na.rm = T)/2, 
        2)
    cat("mean deviance =", mean.deviance, "\n", "p_d =", p_D, "\n", "p =", p, "\n", 
        "DIC =", dic, "\n")
}

##### Generate trace plots #####################################################
tracePlots <- function() {
    pdf(paste(filename, "_traceplots.pdf", sep = ""), width = 10, height = 7.5)
    par(mfrow = c(3, 2), mar = c(0.5, 4, 0.5, 0))
    plot(phi_s, type = "l", xlab = "", ylab = "phi_s", xaxt = "n")
    plot(eta_s, type = "l", xlab = "", ylab = "eta_s", xaxt = "n")
    plot(phi_r, type = "l", xlab = "", ylab = "phi_r", xaxt = "n")
    plot(eta_r, type = "l", xlab = "", ylab = "eta_r", xaxt = "n")
    plot(phi_c, type = "l", xlab = "", ylab = "phi_c", xaxt = "n")
    plot(eta_c, type = "l", xlab = "", ylab = "eta_c", xaxt = "n")
    plot(phi_natl, type = "l", xlab = "", ylab = "phi_natl", xaxt = "n")
    plot(phi_subn, type = "l", xlab = "", ylab = "phi_subn", xaxt = "n")
    plot(phi_comm, type = "l", xlab = "", ylab = "phi_comm", xaxt = "n")
    plot(tau, type = "l", xlab = "", ylab = "tau", xaxt = "n")
    plot(theta_c, type = "l", xlab = "", ylab = "theta_c", xaxt = "n")
    plot(theta_r, type = "l", xlab = "", ylab = "theta_r", xaxt = "n")
    plot(theta_s, type = "l", xlab = "", ylab = "theta_s", xaxt = "n")
    plot(theta_g, type = "l", xlab = "", ylab = "theta_g", xaxt = "n")
    plot(deviance, type = "l", xlab = "", ylab = "deviance", xaxt = "n")
    plot(theta[, 1], type = "l", xlab = "", ylab = "a_g", xaxt = "n")
    plot(theta[, 2], type = "l", xlab = "", ylab = "b_g", xaxt = "n")
    for (i in 1:p) {
        plot(theta[, 2 + 2 * L + 2 * sum(multipleRegionsInSregion) + 2 * J + N + 
            i], type = "l", xlab = "", ylab = paste("covar", i), xaxt = "n")
    }
    for (i in 1:ng) {
        plot(gamma[, i], type = "l", xlab = "", ylab = paste("gamma", i), xaxt = "n")
    }
    for (i in 1:ng) {
        plot(log(sigma2[, i]), type = "l", xlab = "", ylab = paste("sigma2", i), 
            xaxt = "n")
    }
    dev.off()
}
